{-# LINE 33 "Queue.lhs" #-}
  module Algos.DS.Queue ( Queue
                        , emptyQueue
                        , queueFromList
                        , listFromQueue
                        , enqueue
                        , dequeue
                        , front
                        ) where
{-# LINE 104 "Queue.lhs" #-}
  enqueue :: Queue t -> t -> Queue t
  dequeue :: Queue t -> Queue t
{-# LINE 267 "Queue.lhs" #-}
  data Queue t = Queue  {  f, b        :: [t]
                        ,  lenF, lenB  ::  Int
                        }
 
  enqueue q x = checkQueue (q { b = x : b q, lenB = lenB q + 1 })
 
  dequeue q = checkQueue (q { f = tail (f q), lenF = lenF q - 1 })
 
  checkQueue                      ::  Queue t -> Queue t
  checkQueue q@(Queue f b lf lb)  |   lf >= lb   =  q
                                  |   otherwise  =  Queue (f ++ reverse b) [] (lf + lb) 0
{-# LINE 282 "Queue.lhs" #-}
  front                   ::  Queue t -> Maybe t
  front (Queue [] _ _ _)  =   Nothing
  front q                 =   Just (head (f q))
{-# LINE 289 "Queue.lhs" #-}
  queueFromList     ::  [t] -> Queue t
  queueFromList xs  =   Queue xs [] (length xs) 0
 
  listFromQueue                  ::  Queue t -> [t]
  listFromQueue (Queue f b _ _)  =   f ++ reverse b
 
  emptyQueue  ::  Queue t
  emptyQueue  =   queueFromList []
