{-# LINE 30 "BFS.lhs" #-}
  module Algos.Graphs.BFS ( bfs
                          ) where
 
  import Algos.DS.Queue (Queue,emptyQueue,enqueue,dequeue,front)
  import Algos.Graphs.Forest (Forest)
  import Algos.Graphs.Graph (AdjList,V,E,vIx)
  import Algos.Graphs.Traversal (VertexSet(..),traverse)
  import Control.Applicative ((<$>),(<*>))
  import Control.Monad.ST (ST)
  import Data.Array.ST (STArray,newArray,readArray,writeArray,getBounds)
  import Data.STRef (STRef,newSTRef,modifySTRef,readSTRef,writeSTRef)
{-# LINE 52 "BFS.lhs" #-}
  bfs :: AdjList v vl el -> Forest V E
{-# LINE 57 "BFS.lhs" #-}
  bfs = traverse makeVertexQueue
{-# LINE 63 "BFS.lhs" #-}
  data VertexQueue s = VertexQueue (STArray s Int Bool) (STRef s (Queue (V,[(E,V)])))
{-# LINE 69 "BFS.lhs" #-}
  makeVertexQueue    ::  Int -> ST s (VertexQueue s)
  makeVertexQueue n  =   VertexQueue <$> newArray (1,n) False <*> newSTRef emptyQueue
{-# LINE 75 "BFS.lhs" #-}
  instance VertexSet VertexQueue where
 
    add (VertexQueue _   qu) v p = modifySTRef qu (flip enqueue (v,p))
{-# LINE 80 "BFS.lhs" #-}
    remove (VertexQueue exp qu) = readSTRef qu >>= rem
      where  rem q =  case front q of
                        Nothing       ->  writeSTRef qu q >> return Nothing
                        Just p@(v,_)  ->  do  e    <-  readArray exp (vIx v)
                                              if e  then  rem (dequeue q)
                                                    else  do  writeSTRef qu (dequeue q)
                                                              writeArray exp (vIx v) True
                                                              return (Just p)
